#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define SZ 200002

char valid[SZ];
int value[SZ];
char pocet[SZ];
int data1[100001];
int data2[100001];

void addhash( int n ) {
  int pos = n % SZ;
  for( ; valid[pos] && (value[pos] != n); pos = (pos + 1)%SZ );
  valid[pos] = 1;
  value[pos] = n;
  pocet[pos]++;
}

int isdouble( int n ) {
  int pos = n % SZ;
  for( ; value[pos] != n; pos = (pos + 1)%SZ );
  return (pocet[pos]>1);
}

int main()
{
  int N;
  for( scanf( "%d\n", &N ); N>0; N-- ) {
    int N, M;
    int stream=0;
    int h1=0, h2=0;
    int islocked = 0;

    bzero( pocet, sizeof(value) );
    bzero( valid, sizeof(value) );
    bzero( value, sizeof(value) );
    
    scanf( "%d %d\n", &N, &M );
    for( int i=0; i<N; i++ ) {
      int n;
      scanf( "%d", &n );
      data1[i] = n;
      addhash( n );
    }
    for( int i=0; i<M; i++ ) {
      int n;
      scanf( "%d", &n );
      data2[i] = n;
      addhash( n );
    }
    for( ;(h1<N) && (h2<M); ) {
      while( h1<N ) {
//        printf( "got %d at h1:%d\n", data1[h1], h1 ); 
        if ( isdouble(data1[h1]) ) {
//	  printf( "isdouble!\n" );
	  if( data1[h1] == data2[h2] ) {
	    islocked=0;
	    h1++;
	    h2++;
	  } else {
	    islocked++;
	    break; //we're locked!
          }
	} else {
//	  printf( "not double\n" );
	  h1++;
	}
      }
//      printf( "Fall through to second stream\n" );
      while( h2<M ) {
//        printf( "got %d at h2:%d\n", data1[h1], h1 ); 
        if ( isdouble(data2[h2]) ) {
//	  printf( "isdouble!\n" );
	  if( data1[h1] == data2[h2] ) {
	    islocked = 0;
	    h1++;
	    h2++;
	  } else {
	    islocked++;
	    break; //we're locked!
	  }
	} else h2++;
      }
      if( islocked >1 ) break;           
    }
    if( islocked ) printf( "Spatne usporadani.\n" );
    else printf( "Hrac ma sanci vyhrat.\n" );
    
  }

  return 0;
}
