#include <stdlib.h>
#include <stdio.h>
#include <string.h>

int R, S;
char pole[1001][1001];

int cesty[1001][1001];

int cest = 0;


#define canleft( x, y ) (( x+1<S ) && ( pole[y][x+1] == '.' ))
#define candown( x, y ) (( y+1<R ) && ( pole[y+1][x] == '.' ))
 


int go( int x, int y )
{
    int sum = 0;
    if( x == S-1 && y == R-1 ) 
	return 1;
    if( cesty[y][x] != -1 ) {
	return cesty[y][x];
    }
    if( canleft( x, y ) ) {
	sum += go( x+1, y );
    }
    if( candown( x, y ) ) {
	sum += go( x, y+1 );
    }
    cesty[y][x] = sum;
    return sum;
}

int main()
{
  int N;
  for( scanf( "%d\n", &N ); N>0; N-- ) {
    scanf( "%d %d", &R, &S );
    for( int j = 0; j<R; j++ ) {
	scanf( "%s\n", pole[j] );
	for( int i = 0; i<S; i++ ) {
	    cesty[j][i] = -1;
	}
    }
    printf( "Existuje %d ruznych cest.\n", go( 0, 0 ) );   
  }

  return 0;
}
