#include <stdlib.h>
#include <stdio.h>

int pole[1000][1000];

#define platny( x, y ) (x>=0 && y>=0 && x<maxx && y<maxy)
int maxx, maxy;
int x0, y0;

void swap( int x, int y, int x1, int y2 )
{
    int numero = pole[x][y];
    pole[x][y] = pole[x1][y2];
    pole[x1][y2] = numero;
    x0 = x; y0 = y;
}

void najdi( int cislo )
{
    if( platny( x0+1, y0 ) && pole[x0+1][y0] == cislo ) {
	swap( x0+1, y0, x0, y0 );
	printf( "Kamen %d presunut doleva.\n", cislo );
    } else if( platny( x0-1, y0 ) && pole[x0-1][y0] == cislo ) {
	swap( x0-1, y0, x0, y0 );
	printf( "Kamen %d presunut doprava.\n", cislo );
    } else if( platny( x0, y0+1 ) && pole[x0][y0+1] == cislo ) {
	swap( x0, y0+1, x0, y0 );
	printf( "Kamen %d presunut nahoru.\n", cislo );
    } else if( platny( x0, y0-1 ) && pole[x0][y0-1] == cislo ) {
	swap( x0, y0-1, x0, y0 );
	printf( "Kamen %d presunut dolu.\n", cislo );
    } else 
	printf( "Neplatny tah kamenem %d.\n", cislo );
}

int main()
{
  int N, promenna = 0;
  for( scanf( "%d\n", &N ); N>0; N-- ) {
    scanf( "%d %d\n", &maxy, &maxx );
    for( int i=0; i<maxy; i++ ) 
      for( int j=0; j<maxx; j++ ) {
	scanf( "%d", &pole[j][i] );
	if( pole[j][i] == 0 ) {
	    x0 = j; y0 = i;
	}
      }
    promenna++;
    printf( "Skladacka cislo %d:\n", promenna );
    for(;;) {
      int cislo;
      scanf( "%d", &cislo );
      if( cislo == 0 ) break;
      najdi( cislo );
    }
    for( int i=0; i<maxy; i++ ) {
      for( int j=0; j<maxx; j++ ) {
	printf( "%d ", pole[j][i] );
      }
    printf( "\n" );
    }
    
  }
    
  return 0;
}


