#include <stdlib.h>
#include <stdio.h>
#include <string.h>

char pole[ 200 ][ 200 ];
bool mark[ 200 ][ 200 ];

char slova[ 1000 ][ 21 ];
char slovo_char[ 1000 ];
int slovo_pos[ 1000 ];
char min_chars[ 'z' + 1 ];
char chars[ 26 ];
int maxx, maxy;

void right( int x, int y, const char* slovo, int len );
void left( int x, int y, const char* slovo, int len );
void up( int x, int y, const char* slovo, int len );
void down( int x, int y, const char* slovo, int len );
void rightdown( int x, int y, const char* slovo, int len );
void rightup( int x, int y, const char* slovo, int len );
void leftdown( int x, int y, const char* slovo, int len );
void leftup( int x, int y, const char* slovo, int len );

int main()
{
    int N;
    for( scanf( "%d\n", &N ); N>0; N-- )
        {
	for( char i = 'a'; i <= 'z'; ++i )
	    min_chars[ i ] = 0;
        scanf( "%d %d\n", &maxy, &maxx );
        for( int y = 0; y < maxy; ++y )
	    {
          for( int x = 0; x < maxx; ++x )
              {
	      scanf( "%c", &pole[ x ][ y ] );
	      ++ min_chars[ pole[ x ][ y ] ];
	      mark[ x ][ y ] = false;
	      }
	    scanf("\n");
	    }
	for( int i = 0; i < 26; ++ i )
	    chars[ i ] = 'a'+ i;
//	for( int i = 0; i < 26; ++i )
//	    printf( "%c", chars[ i ] );
//	printf( "\n");
//	for( int i = 0; i < 26; ++i )
//	    printf( "%d", min_chars[ i+'a' ] );
//	printf( "\n");
	for( int i = 0; i < 26; ++i )
	    for( int j = i + 1; j < 26; ++j )
		if( min_chars[ j+'a' ] < min_chars[ i+'a' ] )
		    {
		    char tmp = chars[ i ];
		    chars[ i ] = chars[ j ];
		    chars[ j ] = tmp;
		    int tmp2 = min_chars[ j + 'a' ];
		    min_chars[ j + 'a' ] = min_chars[ i + 'a' ];
		    min_chars[ i + 'a' ] = tmp2;
		    }
//	for( int i = 0; i < 26; ++i )
//	    printf( "%c", chars[ i ] );
//	printf( "\n");
        for( int i = 0; i < 1000; ++i )
	    slova[ i ][ 0 ] = '\0';
        int slov_poc = 0;
        char slovo[ 21 ];
	int M;
	for( scanf( "%d\n", &M ); M>0; M-- )
	    {
	    scanf( "%s\n", slovo );
	    int i;
	    for( i = 0;
		 i < slov_poc;
		 ++i )
		 if( !strcmp( slova[ slov_poc ], slovo ))
		     break;
	    if( i != slov_poc )
		continue;
	    strcpy( slova[ slov_poc ], slovo );
	    for( int j = 0; j < 26; j++ )
		{
		char* pos = strchr( slovo, chars[ j ] );
		if( pos != NULL )
		    {
		    slovo_char[ slov_poc ] = chars[ j ];
		    slovo_pos[ slov_poc ] = pos - slovo;
		    break;
		    }
		}
	    ++slov_poc;
    	    }
	for( int i = 0; i < slov_poc; ++i )
	    for( int x = 0; x < maxx; ++x )
		{
		char* pos = strchr( pole[x], slovo_char[ i ] );
		if( pos != NULL )
		    {
		    int y = pos-pole[x];
		    int len = strlen( slova[ i ] );
		    int ln = slovo_pos[ i ];
		    char* slovo = slova[ i ];
		    right( ( x - ln + maxx ) % maxx, y, slovo, len );
		    left( ( x + ln ) % maxx, y, slovo, len );
		    up( x, ( y + ln ) % maxy, slovo, len );
		    down( x, ( y - ln + maxy ) % maxy, slovo, len );
		    rightdown( ( x - ln + maxx ) % maxx, ( y - ln + maxy ) % maxy, slovo, len );
		    rightup( ( x - ln + maxx ) % maxx, ( y + ln ) % maxy, slovo, len );
		    leftdown( ( x + ln ) % maxx, ( y - ln + maxy ) % maxy, slovo, len );
		    leftup( ( x + ln ) % maxx, ( y + ln ) % maxy, slovo, len );
		    }
		}
         for( int y = 0; y < maxy; ++ y )
     for( int x = 0; x < maxx; ++x )
	     if( mark[ x ][ y ] == false)
	         printf( "%c", pole[x ][y ]);
    printf( "\n");
     }
    
  return 0;
}

void right( int x, int y, const char* slovo, int len )
    {
    int xx = x;
    for( int j = 0; j < len; ++j )
	{
	if( xx == maxx ) xx = 0;
	if( slovo[ j ] != pole[ xx ][y] )
	    return;
	++xx;
	}
    xx = x;
    for( int j = 0; j < len; ++j )
	{
	if( xx == maxx ) xx = 0;
	mark[xx][y] = true;
	++xx;
	}
    }
    
void left( int x, int y, const char* slovo, int len )
    {
    int xx = x;
    for( int j = 0; j < len; ++j )
	{
	if( xx == -1 ) xx = maxx - 1;
	if( slovo[ j ] != pole[ xx ][y] )
	    return;
	--xx;
	}
    xx = x;
    for( int j = 0; j < len; ++j )
	{
	if( xx == -1 ) xx = maxx - 1;
	mark[xx][y] = true;
	--xx;
	}
    }

void up( int x, int y, const char* slovo, int len )
    {
    int yy = y;
    for( int j = 0; j < len; ++j )
	{
	if( yy == -1 ) yy = maxy - 1;
	if( slovo[ j ] != pole[ x ][yy] )
	    return;
	--yy;
	}
    yy = y;
    for( int j = 0; j < len; ++j )
	{
	if( yy == -1 ) yy = maxy - 1;
	mark[x][yy] = true;
	--yy;
	}
    }

void down( int x, int y, const char* slovo, int len )
    {
    int yy = y;
    for( int j = 0; j < len; ++j )
	{
	if( yy == maxy ) yy = 0;
	if( slovo[ j ] != pole[ x ][yy] )
	    return;
	++yy;
	}
    yy = y;
    for( int j = 0; j < len; ++j )
	{
	if( yy == maxy ) yy = 0;
	mark[x][yy] = true;
	++yy;
	}
    }

void rightdown( int x, int y, const char* slovo, int len )
    {
    int xx = x;
    int yy = y;
    for( int j = 0; j < len; ++j )
	{
	if( xx == maxx ) xx = 0;
	if( yy == maxy ) yy = 0;
	if( slovo[ j ] != pole[ xx ][yy] )
	    return;
	++xx;
	++yy;
	}
    xx = x;
    yy = y;
    for( int j = 0; j < len; ++j )
	{
	if( xx == maxx ) xx = 0;
	if( yy == maxy ) yy = 0;
	mark[xx][yy] = true;
	++xx;
	++yy;
	}
    }

void rightup( int x, int y, const char* slovo, int len )
    {
    int xx = x;
    int yy = y;
    for( int j = 0; j < len; ++j )
	{
	if( xx == maxx ) xx = 0;
	if( yy == -1 ) yy = maxy-1;
	if( slovo[ j ] != pole[ xx ][yy] )
	    return;
	++xx;
	--yy;
	}
    xx = x;
    yy = y;
    for( int j = 0; j < len; ++j )
	{
	if( xx == maxx ) xx = 0;
	if( yy == -1 ) yy = maxy-1;
	mark[xx][yy] = true;
	++xx;
	--yy;
	}
    }

void leftdown( int x, int y, const char* slovo, int len )
    {
    int xx = x;
    int yy = y;
    for( int j = 0; j < len; ++j )
	{
	if( xx == -1 ) xx = maxx-1;
	if( yy == maxy ) yy = 0;
	if( slovo[ j ] != pole[ xx ][yy] )
	    return;
	--xx;
	++yy;
	}
    xx = x;
    yy = y;
    for( int j = 0; j < len; ++j )
	{
	if( xx == -1 ) xx = maxx-1;
	if( yy == maxy ) yy = 0;
	mark[xx][yy] = true;
	--xx;
	++yy;
	}
    }

void leftup( int x, int y, const char* slovo, int len )
    {
    int xx = x;
    int yy = y;
    for( int j = 0; j < len; ++j )
	{
	if( xx == -1) xx = maxx -1;
	if( yy == -1 ) yy = maxy-1;
	if( slovo[ j ] != pole[ xx ][yy] )
	    return;
	--xx;
	--yy;
	}
    xx = x;
    yy = y;
    for( int j = 0; j < len; ++j )
	{
	if( xx == -1 ) xx = maxx-1;
	if( yy == -1 ) yy = maxy-1;
	mark[xx][yy] = true;
	--xx;
	--yy;
	}
    }

